#include <sourcemod>
#include <sdktools>

#define VERSION "1.0.0"

public Plugin:myinfo = 
{
	name = "L4D2 Remove Upgradepack Restriction",
	author = "ArmGadge",
	description = "Remove character check of upgradepack & Change magazine count",
	version = VERSION,
	url = "http://radiowave.moe.hm/"
};

new Handle:gh_timer_checkaim = INVALID_HANDLE;
new Handle:gh_cv_itemcount = INVALID_HANDLE;
new Handle:gh_cv_display = INVALID_HANDLE;
new Handle:gh_cv_rmcharchk = INVALID_HANDLE;
//new Handle:gh_trie_packeid;

public OnPluginStart()
{
	// Require Left 4 Dead 2
	decl String:game_name[64];
	GetGameFolderName(game_name, sizeof(game_name));
	if (!StrEqual(game_name, "left4dead2", false))
	{
		SetFailState("Plugin supports Left 4 Dead 2 only.");
	}
	
	CreateConVar("l4d2_rmupgrest_version", VERSION, "Version of Remove Upgradepack Restriction Plugin.", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	gh_cv_rmcharchk = CreateConVar("l4d2_rmupgrest_rmcharchk", "1",
		"Remove character check of upgrade pack. If you let one character take twice or more magazines, please set to 1.(0|1)", 0, true, 0.0, true, 1.0);
	gh_cv_itemcount = CreateConVar("l4d2_rmupgrest_count", "12", "Determine how many magazines in a upgrade pack.(int)[count]", 0, true, 0.0, false);
	gh_cv_display = CreateConVar("l4d2_rmupgrest_display", "1", "Display magazine count in the upgrade pack.(0|1)", 0, true, 0.0, true, 1.0);

	
	HookConVarChange(gh_cv_display, OnDisplayChanged);
	
	HookEvent("upgrade_pack_used", Ev_UpgradePackDeployed);
	HookEvent("player_use", Ev_PlayerUse);
	AutoExecConfig(true, "l4d2_rmupgrest");
}

public OnMapStart()
{
	if (GetConVarBool(gh_cv_display) == true)
	{	
		if(gh_timer_checkaim == INVALID_HANDLE)
			gh_timer_checkaim = CreateTimer(0.2, Timer_CheckAim, _, TIMER_REPEAT);
	}
}

public OnMapEnd()
{
	if(gh_timer_checkaim != INVALID_HANDLE)
	{
		KillTimer(gh_timer_checkaim);
		gh_timer_checkaim = INVALID_HANDLE;
	}
}

public Ev_UpgradePackDeployed(Handle:event, const String:name[], bool:dontBroadcast)
{
	//new bool:tookammo[MAXPLAYERS+1];
	//decl String:strbuf_packid[8];
	new upgradeid = GetEventInt(event, "upgradeid");
	//IntToString(upgradeid, strbuf_packid, sizeof(strbuf_packid));
	//PrintToChatAll("upgradepack %d deployed", upgradeid);
	SetEntProp(upgradeid, Prop_Data, "m_itemCount", GetConVarInt(gh_cv_itemcount));
}

public Ev_PlayerUse(Handle:event, const String:name[], bool:dontBroadcast)
{
	new targetid = GetEventInt(event, "targetid");
	//new userid = GetEventInt(event, "userid");
	//new client = GetClientOfUserId(userid);
	
	decl String: classname[32];
	
	if (GetConVarBool(gh_cv_rmcharchk) == true)
	{
		GetEdictClassname(targetid, classname, sizeof(classname));
		if (StrEqual(classname, "upgrade_ammo_incendiary", false) ||
			StrEqual(classname, "upgrade_ammo_explosive", false))
		{
			//m_iUsedBySurvivorsMaskでどのキャラが強化弾薬が取得済みか判定している
			//取った瞬間0にセットして、このキャラチェックを無くす。
			SetEntProp(targetid, Prop_Send, "m_iUsedBySurvivorsMask", 0);
			//AcceptEntityInput(targetid, "InputUse", client, client);
			//SetEntProp(targetid, Prop_Send, "m_iUsedBySurvivorsMask", 15);
		}
	}
}

public Action:Timer_CheckAim(Handle:timer)
{
	decl String:classname[64];
	new ent, count;
	for (new i=1; i<=MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i) && (GetClientTeam(i) == 2) &&
			IsPlayerAlive(i))
		{
			ent = GetClientAimTarget(i, false);
			if (ent >= 0) 
			{
				GetEdictClassname(ent, classname, sizeof(classname));
				if (StrEqual(classname, "upgrade_ammo_incendiary", false) ||
					StrEqual(classname, "upgrade_ammo_explosive", false))
				{
					count = GetEntProp(ent, Prop_Data, "m_itemCount");
					if (StrEqual(classname, "upgrade_ammo_incendiary", false))
					{
						PrintCenterText(i, "Incendiary Ammo Pack (ID %d): x%d", ent, count);
					}
					else if (StrEqual(classname, "upgrade_ammo_explosive", false))
					{
						PrintCenterText(i, "Explosive Ammo Pack (ID %d): x%d", ent, count);
					}
				}
			}
		}
	}
}

public OnDisplayChanged(Handle:cvar, const String:str_oldval[], const String:str_newval[])
{
	new oldval = StringToInt(str_oldval);
	new newval = StringToInt(str_newval);
	if (oldval == 0 && newval == 1)
	{
		if(gh_timer_checkaim == INVALID_HANDLE)
			gh_timer_checkaim = CreateTimer(0.2, Timer_CheckAim, _, TIMER_REPEAT);
	}
	else if (oldval == 1 && newval == 0)
	{
		if(gh_timer_checkaim != INVALID_HANDLE)
		{
			KillTimer(gh_timer_checkaim);
			gh_timer_checkaim = INVALID_HANDLE;
		}	
	}
}